// LCD module connections

sbit LCD_RS at RE2_bit;
sbit LCD_EN at RE1_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at Rd7_bit;

sbit LCD_RS_Direction at TRISE2_bit;
sbit LCD_EN_Direction at TRISE1_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;
// End LCD module connections


void main() {

   char floater_value;
   char highbyte, lowbyte;
   int  tank_temp;
   char text[6];

  //Start  serial communication with Serial Tank
  
  LCD_Init();
  UART1_Init(9600);

  //Turn on OUTLET VALVE 
  LCD_Out(1,1,"TURN ON   OUTLET");
  UART1_Write(0x01);          // 0x01 is the address of OUTLET VALVE
  UART1_Write(0x01);          // WITH 1 WE TURN ON  OUTLET VALVE

  delay_ms(2000);

  //Turn off OUTLET VALVE 
  LCD_Out(1,1,"TURN OFF  OUTLET");
  UART1_Write(0x01);          // 0x01 is the address of OUTLET VALVE
  UART1_Write(0x00);          // WITH 0 WE TURN OFF  OUTLET VALVE


  //Turn ON INLET VALVE
  LCD_Out(1,1,"TURN ON  INLET");
  UART1_Write(0x00);          // 0x01 is the address of INLET VALVE
  UART1_Write(0x01);          // WITH 1 WE TURN OFF  INLET VALVE

  delay_ms(5000);
  
  //Turn OFF INLET VALVE
  LCD_Out(1,1,"TURN ON  INLET");
  UART1_Write(0x00);          // 0x00 is the address of INLET VALVE
  UART1_Write(0x00);          // WITH 0 WE TURN OFF  INLET VALVE


  //READ LOW FLOATER
  UART1_Write(0x11);                // SPECIFY ADDRESS OF LOW FLOATER
  while (!UART1_Data_Ready()) {}     // wait for data from floater
  floater_value = UART1_Read();
  
  if (floater_value == 0)
      LCD_Out(1,1,"TANK IS   EMPTY ");
  else
      LCD_Out(1,1,"TANK  NOT EMPTY ");


  //READ TANK TEMPERATURE
  UART1_Write(0x31);                // SPECIFY  0x31 TANK TEMP
  while (!UART1_Data_Ready()) {}     // wait for data
    highbyte = UART1_Read();          // READ HIGH BYTE
  while (!UART1_Data_Ready()) {}     // wait for data
    lowbyte  = UART1_Read();          // READ LOW BYTE

  tank_temp = highbyte;
  tank_temp = (tank_temp <<8) | lowbyte;



  WordToStr(tank_temp, text);
  LCD_Out(2,1,"TEMP:");
  LCD_Out(2,7, text);
  
}